﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.Assesment
@{
    ViewData["Title"] = "Index";
    //Layout = "~/Views/Shared/_Layout.cshtml";
}
@if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
{
    <script>
        toastr.success('@TempData["success"]');
    </script>
}
else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
{
    <script>
        toastr.error('@TempData["error"]');
    </script>
}
<script src="~/Script/Master/Layout.js"></script>
<script>
    $(document).ready(function () {
        $('.multiple').multiselect({
            enableFiltering: true,
            includeSelectAllOption: true
        });
    });
</script>
<script src="~/Script/Master/Layout.js"></script>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Assesment List</h1>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line" id="dvForm">
                        <form asp-area="ApplicationManagement" asp-controller="Assesment" asp-action="SubmitAssesment" id="form" method="post"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading..."
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/Assesment/Index');"
                              data-ajax-failure="Errmsg(data);">
                            <input type="hidden" name="Id" id="Id" value="@Model.Id" />
                            <input type="hidden" name="EventType" id="EventType" value="@Model.EventType" />
                            <input type="hidden" name="QuestionnaireXML" id="QuestionnaireXML" value="@Model.QuestionnaireXML" />
                            <div class="pb-2 mt-4 mb-2 border-bottom box_title">
                                Set Up Assesment
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Organization</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.OrganizationId, Model.DdlOrganization, "Select Parent Organization", new { @class = "form-control" })
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Category</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.CategoryId, Model.DdlControlCategory, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", @onchange = "fn_GetQuestionnaire(this)" })
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Child Organization</label>
                                    <div class="select_box m_bottom">
                                        <select asp-for="ChildOrgId" asp-items="@(new SelectList(Model.DDlchildOrgs,"Id","ChildOrgName"))" class="form-control">
                                            <option value="0">Select child Organization</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-12">
                                    <h3 class="hidden" id="que">Queries</h3>
                                    <div class="table_control" id="dvmultiTable">
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12 col-sm-6 col-xs-12">
                                    <div class="back_btn">
                                        <div class="back_btn_in">
                                            <input type="button" id="btnBack" name="Submit" value="Back" onclick="hideForm()">
                                        </div>
                                    </div>
                                    <div class="submitbtn">
                                        <input type="submit" id="btnsubmit" name="Submit" value="Submit" onclick="fnSetMultiselectValue()">
                                        <input type="reset" id="reset" value="reset" hidden />
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="addbtn">
                            <div class="add_litigation">
                                <span>+</span>
                                <input type="button" id="btnHideShow" onclick="showForm()" value="Set Up Assesment">
                            </div>
                        </div><!--edn of addbtn-->
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width: 70px;">SN</th>
                                                <th>Organization Name</th>
                                                <th>Control Category</th>
                                                <th>Child Category</th>
                                                <th>Question</th>
                                                <th>Answers</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{
                                                int sn = 0;
                                                var data = Model.Assesments.GroupBy(x => x.OrganizationId, x => x.Assesments, (key, value) => new { OrganizationId = key, Assesments = value });
                                            }
                                            @foreach (var item in Model.Assesments)
                                            {
                                            <tr>
                                                <td>@(++sn)</td>
                                                <td>@(item.ParentOrgName+"-"+item.CorporateOfficeLocation)</td>
                                                <td>@item.CategoryName</td>
                                                <td>@item.ChildOrgName</td>
                                                <td>@item.Question</td>
                                                <td>@item.Answer</td>
                                                <td>
                                                    @*<a href="#" onclick="fnUpdate('@item.Id', '@item.OrganizationId', '@item.CategoryId', '@item.QuestionId')" class="edit_btn"></a>*@
                                                    @*<a href="#" onclick="fnBlockDelete('@item.Id', '@(item.IsActive? "Block" : "UnBlock")', 0)" class="Active_btn">@(item.IsActive? "Block" : "UnBlock")</a>*@
                                                    @*<a href="#" onclick="fnBlockDelete('@item.Id', 'Delete', 1)" class="delete_btn"></a>*@
                                                    <a class="Active_btn" onclick="fn_Activeincative('@item.Id','@(item.IsActive?"deactivate":"activate")')"></a>
                                                    <a class="delete_btn" onclick="Confirmation('@item.Id')"></a>
                                                </td>
                                            </tr>
                                            }
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<script type="text/javascript">
    $("input[type=submit]").click(function () {
        if ($("select[name=OrganizationId]").val() == "" && $("select[name=OrganizationId]").val() == 0) {
            toastr.error("select organization name");
            return false;
        } else if ($("select[name=CategoryId]").val() == null) {
            toastr.error("select a category name");
            return false;
        } else if ($("select[name=ChildOrgId]").val() == 0) {
            toastr.error("select child organization name");
            return false;
        }
    });
    function showForm() {
        $('#dvDataTable').hide();
        $('#dvForm').removeAttr('class');
    }
    function hideForm() {
        $('#reset').click();
        $('#dvDataTable').show();
        $('#dvForm').attr('class', 'service_line');
    }
    function fnSetMultiselectValue() {
        var QuestionnaireXML = [];
        $('#dvmultiTable table').each(function (i, table) {
            var CategoryId = parseInt($(table).attr('id').split('_')[1]);
            var QuesArray = [], iQues = 0;
            $(table).find('thead tr:eq(1) th').each(function (i, th) {
                var quesId = parseInt($(th).attr('name'));
                if (quesId == 0) { return; }
                var AnsArray = [];
                $('.ques' + quesId).each(function (i, input) {
                    AnsArray[i] = {
                        Answer: $(input).val()
                    }
                });
                QuesArray[iQues] = {
                    QuestionId: quesId,
                    AnsArray: AnsArray,
                    //row: iQues
                }
                iQues++;
            });
            QuestionnaireXML[i] = {
                CategoryId: CategoryId,
                QuesArray: QuesArray
            }
        });
        $('#QuestionnaireXML').val(JSON.stringify(QuestionnaireXML));
        console.log(QuestionnaireXML);
    }
    function fn_GetQuestionnaire(select) {
        $("#que").removeClass("hidden");
        $("#dvmultiTable").empty();
        $('#CategoryId option:selected').each(function (i) {
            var CategoryId = $(this).val();
            var CategoryText = $(this).text();
            if (CategoryId == 'multiselect-all') {
                $("#dvmultiTable").empty();
                return;
            }
            var html = '<table class="table" id="tbl_' + CategoryId + '"><thead><tr>';
            $.get('/ApplicationManagement/Compliance/GetQuestionnaireById', { CategoryId: CategoryId }, function (data) {
                html += '<th colspan="' + parseInt(data.length + 2) + '">' + CategoryText + '</th></tr>';
                html += '<tr><th name="0">SN</th>';
                $.each(data, function (i, value) {
                    html += '<th name=' + value.id + '>' + value.query + '</th>';
                });
                html += '<th name="0">Action</th></tr></thead><tbody><tr><td>1</td>';
                $.each(data, function (i, value) {
                    html += '<td><input type="text" class="form-control ques' + value.id + '" /></td>';
                });
                html += '<td><input type="button" class="btn btn-info" value="Add" onclick="AddMoreAnswers(this)"/></td></tr></tbody></table>';
                $("#dvmultiTable").append(html);
            });
        });
        if ($("select[name=CategoryId]").val() == null) {
            $("#que").addClass("hidden");
        }
    }
    function AddMoreAnswers(input) {
        var tdLength = $(input).closest('tr').find('td').length;
        var sn = parseInt($(input).closest('tbody').find('tr:last td:eq(0)').text()) + 1;
        var html = '<tr><td>' + sn + '</td>';
        for (var i = 0; i < tdLength; i++) {
            if (i == 0 || i == tdLength - 1) { continue; }
            html += '<td>';
            html += $(input).closest('tbody').find('tr:first td').eq(i).html();
            html += '</td>';
        }
        html += '<td><input type="button" class="btn btn-danger" value="Remove" onclick="RemoveMoreAnswers(this)"></td></tr>';
        $(input).closest('tbody').append(html);
    }
    function RemoveMoreAnswers(input) {
        $(input).closest('tr').remove();
    }
    function fnUpdate(Id, CountryId, ControlCategory, Query) {
        showForm()
        $('#Id').val(Id);
        $('#CountryId').val(CountryId);
        $('#ControlCategory').val(ControlCategory);
        $('#Query').val(Query);
        $('#EventType').val(1);
    }
    function fnBlockDelete(Id, Action, Type) {
        if (confirm('Are you sure you want to ' + Action + ' this Assesment?')) {
            $.get('/ApplicationManagement/Assesment/BlockDeleteAssesment', { Id: Id, EventType: Type }, function (data) {
                debugger;
                if (data.code == 200) {
                    toastr.success(Action + ' successfully');
                    $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                } else {
                    toastr.error('Something went wrong!');
                }
            });
        }
    }
    function Confirmation(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this assesment',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Assesment/BlockDeleteAssesment",
                    type: "POST",
                    cache: false,
                    data: { Id: id, EventType: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
    function fn_Activeincative(id, status) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to ' + status + ' this assesment',
            showCancelButton: true,
            confirmButtonText: status,
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Assesment/BlockDeleteAssesment",
                    type: "POST",
                    cache: false,
                    data: { Id: id, EventType: Type = 0 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success(status + " " + "successfully!!");
                        $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
</script>